routes/web.php
<?php

use App\Notifications\OrderCreated;
use Illuminate\Support\Facades\App;
use Illuminate\Support\Facades\Notification;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'MainPageController@index')->name('MainPage');
Route::get('/homePage', 'MainPageController@index')->name('mainPage');
Route::post('/homePage', 'MainPageController@subscribe')->name('subscribe');
Route::get('lang/{locale}', 'LangController@lang')->name('lang');
Route::get('page/{id}', 'Dashboard\PageController@show')->name('pages.show');
Route::get('contact_us/', 'ContactController@contact_form')->name('pages.contact_form');
Route::post('contact_us/', 'ContactController@contact_us')->name('pages.contact_us');
Route::get('categories/', 'ProductController@categories')->name('pages.categories');
Route::get('categories/{id}', 'ProductController@cat_products')->name('pages.cat_products');
Route::get('product/{id}', 'ProductController@show')->name('pages.product');
Route::get('productOwner/{id}', 'ProductController@owner')->name('pages.owner');
Route::post('comment_store/', 'ProductController@commentStore')->name('comment.store');
Route::post('product/', 'ProductController@rateStore')->name('pages.productRate');
Route::get('search/', 'ProductController@search')->name('pages.search');
Route::get('search/filters', 'ProductController@filters')->name('pages.search.filters');
Route::resource('/basket','basket\ParentBasketController');

Auth::routes(['verify' => true]);

Route::get('search/autocompleteUsers', 'UserController@autocomplete')->name('autocompleteUsers');
//Route::get('artisan', function() {
//    Artisan::call('migrate '  );
//    Artisan::call('db:seed '  );
//});
//Route::get('/test', function (){
//    return view('emails.message',['receiver'=>\App\Models\Admin::find(1),'sender'=>\App\Models\Admin::find(2),'id'=>3,'lang'=>App::getLocale(),'prefix'=>'admin.']);
//});
//Route::get('/rl',function (){
//    \Illuminate\Support\Facades\Artisan::call('route:list');
//    dd(\Illuminate\Support\Facades\Artisan::output());
//
//});

//--------------------Admins------------------------------
Route::group(['prefix'=>'admin'],function (){
    Route::get('/login','Auth\AdminLoginController@showLoginForm')->name('admin.login');
    Route::post('/login','Auth\AdminLoginController@login')->name('admin.login.submit');
    Route::get('/logout', 'Auth\AdminLoginController@logout')->name('admin.logout');
    Route::group(['middleware' => 'auth:admin'],function (){
        Route::resource('/menu','Admin\MenuController');
        Route::resource('/link_locations','Admin\LinkLocationsController');
        Route::resource('/link','Admin\LinkController');
        Route::resource('/page','Admin\PageController');
        Route::resource('/product_category','Admin\ProductCategoryController');
        Route::get('/','Admin\AdminController@index')->name('admin.dashboard');
        Route::resource('user', 'Admin\UserController', ['except' => ['create','store']]);
        Route::resource('/product','Admin\ProductController');
        Route::post('/newsletter_upload', 'Admin\SubscribeController@UploadFile')->name('admin.upload_file_newsletter');
        Route::post('/upload','Admin\ProductController@UploadFile')->name('upload_file_product');
        Route::post('/remove','Admin\ProductController@RemoveFile')->name('remove_file_product');
        Route::name('admin.')->group(function () {
            Route::resource('/message', 'MessageController', ['as', 'admin']);
        });
        Route::get('/message_Receiver', 'MessageController@autocomplete')->name('admin.autocompleteReceiver');
        Route::post('/message_upload', 'MessageController@upload')->name('admin.upload_file_message');
        Route::post('/message_remove', 'MessageController@remove')->name('admin.remove_file_message');
        Route::get('/attachment_view/{name_file}', 'MessageController@show_attachments')->name('admin.show_attachments');
        Route::get('/message_sent', 'MessageController@SentMessages')->name('admin.message_sent');
        Route::get('/message_reply/{id}', 'MessageController@ReplyMessages')->name('admin.message_reply');
        Route::get('/contacts','ContactController@index')->name('admin.contacts');
        Route::get('/contacts/{id}','ContactController@show')->name('admin.show_contacts');
        Route::resource('/comment','Admin\CommentController')->except('store');
        Route::resource('/subscribe','Admin\SubscribeController');
        Route::get('/subscribe_excel/{id}','Admin\SubscribeController@receivers')->name('subscribe_excel');
        Route::get('/subscribe_send/{id}','Admin\SubscribeController@send')->name('subscribe_send');
        Route::group(['prefix'=>'notification'],function (){
            Route::get('','Admin\NotificationController@index')->name('admin.notifications');
            Route::delete('{id}','Admin\NotificationController@destroy')->name('admin.delete_notifications');
            Route::get('delete_all','Admin\NotificationController@destroy_all')->name('admin.destroy_notifications');
            Route::post('user','Admin\NotificationController@notify_user')->name('admin.notify_user');

        });
    });
});

//--------------------Normal Users------------------------------
/*dashboard*/ Route::get('/home', 'UserController@dashboard')->name('dashboard')->middleware('verified');
Route::group( ['middleware' => 'auth'],function (){
    Route::get('/logout', 'Auth\LoginController@logout')->name('logout.a');
    Route::group(['middleware' => 'verified'], function () {
        Route::get('profile', ['as' => 'profile.edit', 'uses' => 'Dashboard\ProfileController@edit']);
        Route::put('profile', ['as' => 'profile.update', 'uses' => 'Dashboard\ProfileController@update']);
        Route::get('profile/password', ['as' => 'profile.change_password', 'uses' => 'Dashboard\ProfileController@change_password']);
        Route::put('profile/password', ['as' => 'profile.password', 'uses' => 'Dashboard\ProfileController@password']);
        Route::get('notifications', ['as' => 'pages.notifications', 'uses' => 'Dashboard\PageController@notifications']);
        Route::delete('notifications/{id}','Dashboard\PageController@destroyNotifications')->name('delete_notifications');
        Route::get('notifications/delete_all','Dashboard\PageController@destroyAllNotifications')->name('destroy_notifications');
        Route::resource('/userProduct','Dashboard\ProductController');
        Route::get('/productCountLog/{id}',function ($id){
            if(\Illuminate\Support\Facades\Storage::exists('product_count_logs/'.$id.'.txt'))
                return \Illuminate\Support\Facades\Storage::download('product_count_logs/'.$id.'.txt');
            else abort(404);
        })->name('productCountLog');
        Route::post('/upload','Dashboard\ProductController@UploadFile')->name('upload_file_user_product');
        Route::post('/remove','Dashboard\ProductController@RemoveFile')->name('remove_file_user_product');
        Route::resource('/message','MessageController');
        Route::get('/message_Receiver', 'MessageController@autocomplete')->name('autocompleteReceiver');
        Route::post('/message_upload', 'MessageController@upload')->name('upload_file_message');
        Route::post('/message_remove', 'MessageController@remove')->name('remove_file_message');
        Route::get('/message_sent', 'MessageController@SentMessages')->name('message_sent');
        Route::get('/message_reply/{id}', 'MessageController@ReplyMessages')->name('message_reply');
        Route::get('/attachment_view/{name_file}', 'MessageController@show_attachments')->name('show_attachments');
        Route::post('/shop', 'OrderController@create')->name('shop');
        Route::resource('/order','OrderController')->except(['edit','update']);
        Route::get('/confirm_order/{id}','OrderController@confirm')->name('confirm_order');
        Route::get('/problem_order/{id}','OrderController@problem')->name('order_problem');
    });
});

//-------------------Normal Users And Admins-------------------------
Route::group( ['middleware' => 'auth:web,admin'],function (){
    Route::get('/requested_orders','OrderController@requested')->name('requested_orders');
    Route::get('/order/{id}/edit', 'OrderController@edit')->name('order_edit');
    Route::put('/order/{id}/edit',  'OrderController@update')->name('order_update');
    Route::post('/order/desc',  'OrderController@problem_desc')->name('order_desc');
    Route::get('/receipt_images/{name_file}','OrderController@receipt');
});

app/Models/Comment.php
<?php

namespace App\Models;

use App\Helpers\Helper;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Comment extends Model
{
    use HasFactory;
    protected $fillable = [
        'created_at',
        'updated_at',
        'products_id',
        'name',
        'email',
        'comment'
    ];

    public function product(){
        return $this->belongsTo(Product::class,'products_id','id');
    }
}

app/Http/Controllers/Admin/CommentController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Helpers\Helper;
use App\Http\Controllers\Controller;
use App\Models\Comment;
use Illuminate\Http\Request;

class CommentController extends Controller
{
    public function __cunstruct(){
        $this->middleware('auth:admin');
    }

    public function index(Request $request)
    {
        $result = Comment::select('comments.*','p.id as p_id','p.title')->orderBy('comments.id','DESC')
        ->join('products As p',function ($join){
                $join->on('p.id', '=', 'comments.products_id')
                    ->where('p.lang_id',Helper::GetLocaleNumber());
            } );
        if($request->product_title) $result = $result->where('p.title','LIKE','%'.$request->product_title.'%');
        if($request->name) $result = $result->where('name','LIKE','%'.$request->name.'%');
        if($request->email) $result = $result->where('email','LIKE','%'.$request->email.'%');
        if($request->date_from)  $result = $result->where('comments.created_at','>=',StringToDate($request->date_from));
        if($request->date_to)   $result = $result->where('comments.created_at','<=',StringToDate($request->date_to));

        $result = $result->paginate(10);
        return view('comment.index',['list'=> $result,'request'=>$request]);
    }


    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $record = Comment::findOrFail($id);
        $record->load('product');
        return view('comment.show',compact('record'));
    }



    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $record =  Comment::findOrFail($id);

        $record->delete();
        return back()->with('message', __('messages.deleted'));
    }



}

resources/views/comment/comment.blade.php
<div class="col-xl-12 col-lg-5  co-sm-l2  comments ">
    <h3>{{__('comments')}}</h3>
    <form action="{{route('comment.store')}}" method="post" enctype="multipart/form-data">
        {{csrf_field()}}

        <input type="hidden" name="product_id" value="{{$product->id}}">
        <div class="col-xl-5 col-md-5 inline">
            <label for="name" class=" control-label ">{{ __('title.name')}}  </label>
            <input id="name" type="text" class="form-control" name="name" value="{{ old('name') }}"  autofocus>
            @include('alerts.feedback', ['field' => 'name'])
        </div>

        <div class="col-xl-5 col-md-5 inline">
            <label for="email" class=" control-label ">{{ __('title.email')}} </label>
            <input id="email" type="text" class="form-control" name="email" value="{{ old('email') }}"  autofocus>
            @include('alerts.feedback', ['field' => 'email'])
        </div>

        <div class="col-xl-10">
            <label for="comment" class="col-md-4 control-label ">{{ __('title.comment')}} <span class="require">*</span> </label>
            <textarea class="form-control textarea"  type="text" name="comment" required>{{old('comment')}}</textarea>
            @include('alerts.feedback', ['field' => 'comment'])
        </div>

        <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12">
        @if(config('services.recaptcha.key'))
            <div class=" ">
                <div class="g-recaptcha"  data-sitekey="{{config('services.recaptcha.key')}}">
                </div>
            </div>
            @include('alerts.feedback', ['field' => 'g-recaptcha-response'])
        @endif
        </div>
        <div class="col-xl-12 col-lg-12 col-md-12 col-sm-12">
            <button class="send">Send</button>
        </div>

    </form>
    @if(!empty($comments[0]))
        <div class="col-xl-11 comments_list">
            <h4>{{__('others comments')}}</h4>
            @include('comment.list')
        </div>

    @endif

</div>

resources/views/comment/index.blade.php
@extends('layouts.green_layout')
@section('title')
    | {{__("title.comments")}}
@endsection
@section('content')
    <div class="inner_page dashboard">
        <div class="col-xl-12 row">
            @include('layouts.navbars.nav_check')
            <div class="col-xl-9 " style="margin-top: 10px" >
                @include('includes.message')

                    <table border="1" cellpadding="20" class="table table-hover inner_page_box">
                    <thead>
                    <tr>
                        <th colspan="7" class="th_title">
                            <span>{{__('title.comments')}}</span>
                        </th>
                    </tr>

                    <tr >
                        <td></td>
                        <td></td>
                        <td>{{ __('title.product_title')}}</td>
                        <td>{{ __('title.name')}}</td>
                        <td>{{ __('title.email')}}</td>
                        <td>{{ __('title.body')}}</td>
                        <td>{{ __('title.created')}}</td>
                    </tr>
                    </thead>
                    <tbody>

                    @foreach($list as $item)
                            <tr class="{{$item->id}}">
                                <td class="btn-td">
                                    <form action="{{route('comment.destroy',$item->id)}}" method="post">
                                        {{method_field('delete')}}
                                        {{csrf_field()}}
                                        <input type="submit" value=""  class="btn btn-danger" title="{{__('title.delete')}}" onclick="return confirm('{{__('title.confirm_delete')}}')">
                                    </form>
                                </td>
                                <td class="btn-td">
                                    <a href="{{route('comment.show',$item->id)}}" class="btn btn-show " > </a>
                                </td>
                                <td>{{$item->title}}</td>
                                <td>{{$item->name}}</td>
                                <td>{{$item->email}}</td>
                                <td>{{substr($item->comment,0,100)}}</td>
                                <td>
                                    @if(app()->getLocale() == 'fa')
                                        <div style="direction: ltr"> {{PersianNo(dateConvert::strftime('Y/m/d H:i:s', strtotime($item->created_at)))}}</div>
                                    @else {{$item->created_at}}
                                    @endif
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
                 {{$list->appends(request()->query())->links()}} <!-- PAGINATION-->
                <form method="'get" action="{{route('comment.index')}}" class="search-form inner_page_box">
                <div class="form-search">
                    <label for="product_title">{{ __('title.product_title')}}: </label>
                    <input type="text" name="product_title" value="{{$request->product_title}}" class="form-control"  >
                </div>
                <div class="form-search">
                    <label for="name">{{ __('title.name')}}: </label>
                    <input type="text" name="name" value="{{$request->name}}" class="form-control"  >
                </div>
                <div class="form-search">
                    <label for="email">{{ __('title.email')}}: </label>
                    <input type="text" name="email" value="{{$request->email}}" class="form-control"  >
                </div>

                <div class="form-search">
                    <label for="date_from">{{ __('title.date_from')}}: </label>
                    <input class="form-control date" name="date_from" type="text" value="{{$request->date_from}}">

                </div>
                <div class="form-search">
                    <label for="date_to">{{ __('title.date_to')}}: </label>
                    <input class="form-control date" name="date_to" type="text" value="{{$request->date_to}}">

                </div>


                <div class="clearfix"></div>
                <input type="submit" value="{{ __('title.search')}}" class="btn btn-primary">
                <a href="{{route('comment.index')}}" class="btn btn-reset" >  {{ __('title.reset_filters')}}</a>
            </form>
            </div>
        </div>
    </div>
@endsection
@section('scripts')
    // TODO: fill date picker on selected values
    <script>
    @if(app()->getLocale() == 'fa')
    $(document).ready(function() {
        $(".date").persianDatepicker({
            initialValue: false,
            formatDate: "YYYY-0M-0D",
            // selectedDate:$(this).val()

        });

    });
    @else
     $(".date").datepicker({
        format: 'Y-m-d',
    });
    @endif
</script>
@endsection

resources/views/comment/list.blade.php
        @foreach($comments as $comment)
            <div class="comments_detail">
                <div class="col-xl-5 col-lg-5 col-md-5 col-sm-12  comment_date">
                    @if(app()->getLocale() == 'fa') <div style="direction: ltr"> {{PersianNo(dateConvert::strftime('Y/m/d', strtotime($comment->created_at)))}}</div>
                    @else {{$comment->created_at}}
                    @endif
                </div>
                <div class="col-xl-5 col-lg-5 col-md-5 col-sm-12  comment_name">{{$comment->name}}   </div>
                <div class="comment_body">{{$comment->comment}}</div>
            </div>
        @endforeach

        <div class="navigations">
            @if(!empty($comments->nextPageUrl()))
                <button class="read-more" style="float: none;margin-top: -34px;" onclick="Getmore()">more</button>
            @endif
        {{$comments->appends(request()->query())->links()}} <!-- PAGINATION-->
        </div>

resources/views/comment/show.blade.php
@extends('layouts.green_layout')
@section('title')
    | {{__("title.comments")}}
@endsection
@section('content')
    <div class="inner_page dashboard">
        <div class="col-xl-12 row">
            @include('layouts.navbars.nav_check')
            <div class="col-xl-9 " style="margin-top: 10px" >
                @include('includes.message')
                <div class="card">
                    <div class="flex-center position-ref full-height">
                    <h5>{{__('title.comments')}} </h5>

                    <div class="form-group">
                        <label for="pro_name" class="col-md-4 control-label ">{{ __('title.product_title')}}  </label>
                        <div class="col-md-6">
                            <a href="{{route('product.edit',$record->product->id)}}" >
                                <span class="form-control tim-icons icon-refresh-02">  {{$record->product->title}}   </span></a>
                        </div>
                    </div>

                    <div class="form-group col-xl-5 inline">
                        <label for="name" class="col-md-4 control-label ">{{ __('title.name')}}  </label>
                        <input id="name" type="text" class="form-control" name="name" value="{{ $record->name }}"  autofocus>
                    </div>

                    <div class="form-group col-xl-5 inline">
                        <label for="email" class="col-md-4 control-label ">{{ __('title.email')}} </label>
                        <input id="email" type="text" class="form-control" name="email" value="{{ $record->email }}"  autofocus>
                    </div>

                    <div class="form-group col-xl-10">
                        <label for="comment" class="col-md-4 control-label ">{{ __('title.comment')}} <span class="require">*</span> </label>
                        <textarea class="form-control textarea"  type="text" name="comment" required>{{$record->comment}}</textarea>
                    </div>

                    <div class="col-xl-10" style="margin-top: 20px">
                    </div>
                </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/comment/star.blade.php
<div class="col-xl-12 " style="direction: ltr" id="star_rate_part">


    <form id="star_rate_form" route="{{route('pages.productRate')}}" >
    <fieldset class="starability-growRotate">
        @for($i=1;$i<=5;++$i)
            <input type="radio" id="growing-rotating-rate{{$i}}" name="rating" value="{{$i}}"
            @if($product->rate>= $i) checked="checked" @endif>
            <label for="growing-rotating-rate{{$i}}" >{{$i}} star</label>
        @endfor
    </fieldset>
    </form>
    <div class="col-xl-2 direction star_desc">
        @if($product->sum_rate >0 )
            {{$product->rate}} {{__('from')}}  5  {{__('from sum')}} {{$product->sum_rate}} {{__('rates')}}
        @endif
    </div>
    @if($product->visited_count>10)
        <div class="col-xl-2 direction star_desc">
            {{$product->visited_count}} {{__(' times visited ')}}
        </div>
    @endif
</div>